-- Straightface Studios 2017
-- www.sfstudios.com
-- Gavin Greenwalt
-- v01

try(destroyDialog PRT2Forest)catch();

rollout PRT2Forest "PRT to Forest" width:192 height:210;
(
	local prt
	local obj
	local forest
	
	pickbutton SelectPRT "Select PRT Loader" pos:[8,10] width:176 height:64;
	pickbutton SelectObj "Select Object" pos:[8,74] width:176 height:64;
	button MakeInstances "Create Forest" pos:[8,138] width:176 height:64;
	
	fn instanceObjs = 
	(		
		instanceObj = obj
		dims = instanceObj.max - instanceObj.min
		prtCount = 0
		proceed = true
		
		forest = Forest_Pro name:"PRT_To_Trees" mode:1 isSelected:false
		forest.mode = 1
		forest.cobjlist[1] = instanceObj
		forest.geomlist[1] = 2
		forest.trees.update_ui()
		
		forest.trees.update()
		forest.trees.update_ui()
		
		if (classof  prt == PF_Source) then (prtCount = prt.NumParticles())
		else if (classof prt == MixinInterface) then (prtCount = prt.getCount())
			
		
		
		if prtCount > 10000 do proceed = (querybox "There are more than 10000 instances.  \n Instancing may take a very long time or approach infinity.  \n You should use the mesh to particle feature built into ForestPack. \nProceed anyway (may freeze max)?")
		
		if proceed do 
		(
			
			print "Beginning PRT to Forest"
			--progressStart "Growing Trees"
			--disablesceneredraw()
			t = timestamp()
			parts = #()
			
			if (classof prt == PF_Source) then 
			(
				for i = 1 to prtCount do 
				(
					prt.particleID = i
					append parts prt.particlePosition
				)
			)
			else if (classof prt == MixinInterface) then 
			(
				for i = 1 to prtCount do 
				(
					append parts (prt.readParticle())[1]
				)
			)
				
			print ("Done Retrieving PRT objects:" + ((timestamp()-t) as string) + "ms")
			
			c = 1
			increment = 1000
			
			for j = 1 to ((prtCount/increment)+1) do
			(
				iloop = (amin (prtCount - ((j-1)*increment)) increment)
				for i = 1 to iloop do
				(
					forest.trees.create parts[c] 1 1 1
					forest.trees.setSize (forest.trees.count()-1) dims
					c+=1
					--if getProgressCancel() do break
				)
				--if not (progressUpdate (j*1000.0/prtCount)) do break
			)
		
			
			forest.trees.update()
			forest.trees.update_ui()

			enablesceneredraw()
			progressEnd()
			print ("Finished PRT to Forest in " + (((timestamp()-t)/1000.0) as string) + " seconds.")
		)
		
	)

	on SelectPRT picked pObj do 
	(
		if (ClassOf pObj == KrakatoaPRTLoader or ClassOf pObj == PF_Source) then
		(	
			if (classof  pObj == PF_Source) then (PRT2Forest.prt = pObj)
			else if (classof pObj == KrakatoaPRTLoader) then (PRT2Forest.prt = FranticParticles.GetPRTObjectIStream pObj false false)
			SelectPRT.text = "PRT:"+pObj.name
		) else ( messageBox "Not a PRT Loader")

		
	)
	
	on SelectOBJ picked pObj do 
	(
		if SuperClassOf pObj == GeometryClass then
		(		
			obj = pObj
			SelectOBJ.text = "Object:"+pObj.name
		) else ( messageBox "Not an object"	)
		
	)
	
	on MakeInstances pressed do 
	(
		instanceObjs()
	)
)

createDialog PRT2Forest

